# Crashpad: crashpad::internal::MemorySnapshotMac Class Reference

crashpad::internal::MemorySnapshotMac Class Referencefinal

A MemorySnapshot of a memory region in a process on the running system, when the system runs macOS. More...

`#include "snapshot/mac/memory_snapshot_mac.h"`

Inheritance diagram for crashpad::internal::MemorySnapshotMac:

## Public Member Functions

void | Initialize (ProcessReader *process_reader, uint64_t address, uint64_t size)
| Initializes the object. More...
uint64_t | Address () const override
| The base address of the memory snapshot in the snapshot process’ address space.
size_t | Size () const override
| The size of the memory snapshot.
bool | Read (Delegate *delegate) const override
| Calls Delegate::MemorySnapshotDelegateRead(), providing it with the memory snapshot’s data. More...

## Detailed Description

A MemorySnapshot of a memory region in a process on the running system, when the system runs macOS.

## Member Function Documentation

## Initialize()

void crashpad::internal::MemorySnapshotMac::Initialize | ( | ProcessReader * | process_reader,
|  | uint64_t | address,
|  | uint64_t | size
| ) |  |

Initializes the object.

Memory is read lazily. No attempt is made to read the memory snapshot data until Read() is called, and the memory snapshot data is discared when Read() returns.

Parameters

  [in] | process_reader | A reader for the process being snapshotted.
  [in] | address | The base address of the memory region to snapshot, in the snapshot process’ address space.
  [in] | size | The size of the memory region to snapshot.

## Read()

bool crashpad::internal::MemorySnapshotMac::Read | ( | Delegate * | delegate | ) | const

overridevirtual

Calls Delegate::MemorySnapshotDelegateRead(), providing it with the memory snapshot’s data.

Implementations do not necessarily read the memory snapshot data prior to this method being called. Memory snapshot data may be loaded lazily and may be discarded after being passed to the delegate. This provides clean memory management without burdening a snapshot implementation with the requirement that it track all memory region data simultaneously.

Returns
  `false` on failure, otherwise, the return value of Delegate::MemorySnapshotDelegateRead(), which should be `true` on success and `false` on failure.

Implements crashpad::MemorySnapshot.

The documentation for this class was generated from the following files:

- snapshot/mac/memory_snapshot_mac.h
- snapshot/mac/memory_snapshot_mac.cc